#include <stdio.h>
#include <math.h>

int t,n, p,q,r1,r2,c1,c2;

int z[202][202];
char vid[202][202];
char boli[202][202];

int fr[42000];
int fc[42000];
int fk[42000];
int fzac, fkon;

int isZero(double d)
{
    int c = d+.5;
    if (fabs(d-c) < 0.0001) return 1;
    return 0;
}

int hit(double r, double c, double v)
{
    return (z[(int)r][(int)c] > (int)v);
}

int test(double sx, double sy, double sz, double dx, double dy, double dz,
int k)
{
    for (int i = 0; i < k; i++) {
        sx += dx;
        sy += dy;
        sz += dz;
        int nzero = isZero(sx)+isZero(sy)+isZero(sz);
        if (nzero >= 2) continue;
        if (isZero(sx)) {
            if (hit(sx-0.5,(int)sy,sz)) return 1;            
            if (hit(sx+0.5,(int)sy,sz)) return 1;            
        }
        if (isZero(sz)) {
            if (hit(sx,sy,sz-0.5)) return 1;
            if (hit(sx,sy,sz+0.5)) return 1;            
        }
        if (isZero(sy)) {
            if (hit(sx,sy-0.5,sz)) return 1;            
            if (hit(sx,sy+0.5,sz)) return 1;            
        }
    }
    return 0;
}

int tst(int r, int c, int rv, int cv)
{
    double sx = r+0.5;
    double sy = c+0.5;
    double sz = z[r][c] + 0.5;
    double svx = rv+0.5;
    double svy = cv+0.5;
    double svz = z[rv][cv] + 0.5;
    double dx = svx-sx;
    double dy = svx-sx;
    double dz = svx-sx;
    double k = fabs(dx);
    if (k > 0.5) {
        if (test(sx,sy,sz, dx/k/2.0,dy/k/2.0,dz/k/2.0,2*k+0.2)) return 0;
    }
    k = fabs(dy);
    if (k > 0.5) {
        if (test(sx,sy,sz, dx/k/2.0,dy/k/2.0,dz/k/2.0,2*k+0.2)) return 0;
    }
    k = fabs(dz);
    if (k > 0.5) {
        if (test(sx,sy,sz, dx/k/2.0,dy/k/2.0,dz/k/2.0,2*k+0.2)) return 0;
    }
    return 1;
}

int vidim(int r, int c)
{
    if (vid[r][c] == 10) {
        if (tst(r,c, r1,c1)) vid[r][c] = 1;
        else if (tst(r,c, r2,c2)) vid[r][c] = 1;
        else vid[r][c] = 0;
    }
    return vid[r][c];
}

int possible(int r,int c,int vyska) {
    if (boli[r][c]) return 0;
    if (z[r][c]<vyska-3) return 0;
    if (z[r][c]>vyska+1) return 0;
    if (!vidim(r,c)) return 0;
    return 1;
}

void insert(int r, int c, int k)
{
    boli[r][c] = 1;
    fr[fkon] = r;
    fc[fkon] = c;
    fk[fkon] = k;
    fkon++;
}

int main()
{
    scanf("%d ", &t);
    for (int ii = 0; ii < t; ii++) {
        scanf("%d %d ",&p, &q);
        for (int j = 0; j < p; j++) {
            for (int i = 0; i < q; i++) {
                scanf("%d ", &(z[j][i]));
            }
        }
        scanf("%d %d %d %d ", &r1, &c1, &r2, &c2);
        r1--;
        r2--;
        c1--;
        c2--;
        
        for (int j = 0; j < p; j++) {
            for (int i = 0; i < q; i++) {
                vid[j][i] = 10;
                boli[j][i] = 0;
            }
        }
        
        fzac = 0;
        fkon = 1;
        fr[0] = r1;
        fc[0] = c1;
        fk[0] = 0;
        int r,c;
        while (fzac != fkon) {
            r = fr[fzac];
            c = fc[fzac];
            if (r == r2 && c == c2) break;
            if (r > 0 && possible(r-1,c,z[r][c])) insert(r-1,c,fk[fzac]+1);
            if (c > 0 && possible(r,c-1,z[r][c])) insert(r,c-1,fk[fzac]+1);
            if (r < p-1 && possible(r+1,c,z[r][c])) insert(r+1,c,fk[fzac]+1);
            if (c < q-1 && possible(r,c+1,z[r][c])) insert(r,c+1,fk[fzac]+1);
      
            fzac++;
        }
        if (r == r2 && c == c2) {
            printf("The shortest path is %d steps long.\n", fk[fzac]);
        } else 
            printf("Mission impossible!\n");
    }
    return 0;
}